
#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <ctype.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <dirent.h>
#include <asm/param.h>
#include <syslog.h>

struct linuxtime {
    int tv_sec;
    int tv_nsec;
};

struct linprocdata {
    char *pr_fname;
    int   pr_pid;
    uid_t pr_uid;
    struct linuxtime pr_time;
};


/*
 * Basically we take all of the data available to us and package what is
 * wanted by autonice in struct procdata.
 */
int linuxproc(char *path, struct linprocdata *ps)
{
  FILE *fp;
  int pid;
  char      comm[1024];
  char      S[1024];
  char      state;
  int       ppid, pgrp, session, tty, tpgid;
  unsigned  int flags, min_flt, cmin_flt, maj_flt, cmaj_flt;
  int       utime, stime, cutime, cstime, priority, nice;
  unsigned  timeout, it_real_value;
  int       start_time;
  unsigned  vsize, rss, rss_rlim, start_code, end_code, start_stack;
  unsigned  kstk_esp, kstk_eip;
  int       signal, blocked, sigignore, sigcatch;
  unsigned  wchan;

  char* tmp;
  struct stat stbuf;
  char   *process;
  int ret;

    process = malloc(strlen(path)+6);
    if (process == NULL)
      return -1;
    snprintf(process,strlen(path)+6,"%s/stat",path);

    if ((fp = fopen(process,  "r")) == NULL)
    {
      printf("can't open it\n");
      return -1;
    } else {
    
    (void) fgets(S, 1024, fp);                 /* get the whole file */
    tmp=strrchr(S, ')');                /* split to "PID (cmd" */
    if (tmp) *tmp = '\0';               /* replace trialing ')' */

    memset(comm, 0, sizeof comm);   /* clear the var comm*/
    if ((ret = sscanf(S, "%d (%39c", &pid, comm)) != 2)
    {
	syslog(LOG_INFO, "Could not extract pid and comm from /proc/<pid>/stats");
	return -1;
    }
    sscanf(tmp+2,
           "%c %d %d %d %d %d %u %u %u %u %u %d %d %d %d %d %d %u %u %d %u %u %u %u %u %u %u %u %d %d %d %d %u",
           &state, &ppid, &pgrp, &session, &tty, &tpgid,
           &flags, &min_flt, &cmin_flt, &maj_flt, &cmaj_flt,
           &utime, &stime, &cutime, &cstime, &priority, &nice,
           &timeout, &it_real_value, &start_time, &vsize, &rss,
           &rss_rlim, &start_code, &end_code, &start_stack,
           &kstk_esp, &kstk_eip, &signal, &blocked, &sigignore,
           &sigcatch, &wchan);
     stat(process,&stbuf);

     ps->pr_fname=strdup(comm);
     ps->pr_pid=pid;
     ps->pr_time.tv_sec=(cutime+cstime)/HZ; /*(HZ: 1/clock->convert from jiffies*/
     ps->pr_time.tv_nsec=0;               /*not sure about linux timing yet*/
     ps->pr_uid=stbuf.st_uid;
    }
    fclose(fp);
    free(process);
    return 0;
}

void linuxprocfree (struct linprocdata *ps)
{
  if (ps!=NULL && ps->pr_fname!=NULL)
    free(ps->pr_fname);
}
